# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ ó
#P:/60_PGM/_SRC/m17_01_PrintPasF.py
"""
Definuje funkci printpasf jako alternativu k funkci printpas
z modulu m12_01_Pascal.
Funkce printpasf se už umí vyrovnat s proměnlivým počtem cifer
v položkách trojúhelníku a řešit jejich zarovnání.
"""



#Výpis 17.11: Definice funkce printpasf() v modulu m17_01_PrintPasF
############################################################################
print( '===== START načítání modulu', __name__, '=====')


def printpasf(pas):
    """Vrátí string zobrazující zadaný Pascalův trojúhelník
       jako rovnoramenný trojúhelník.
       Upravuje řešení z modulu m12_01_Pascal použitím f-stringů.
    """
    deep = len(pas)     # Počet řádků trojúhelníku
    s    = ""           # String pro vytvářený trojúhelník
    # Největší číslo musí být v posledním řádku
    m    = len(str(max(*pas[deep-1]))) + 1  # Pozic pro největší číslo
    for r in range(deep):   # Převádí řádek za řádkem
        # Odsazení řádku je ovlivněno velikostí největšího čísla a
        s += (m*(deep-r-1)//2) * ' '    # pořadím aktuálního řádku
        for c in range(len(pas[r])):    # Přidáme jednotlivé prvky řádku
            # f = '.' if c&1 else '^'   # Pro zvýraznění stylu zarovnání
            # můžeme definovat střídavá plnění pro sudé a liché prvky
            f = ' '   # Nepotřebujeme-li vidět, jak zarovnává
            s += f'{pas[r][c]:{f}^{m}}' # Čísla oddělí plněním
        s += '\n'   # A řádek ukončí
    return s


print('===== KONEC načítání modulu''', __name__, '=====')
