# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m22_01_LABC.py
"""
Definice demonstračních tříd k výkladu jednoduchého dědění.
"""



#Výpis 22.1: Definice tříd LA, LB a LC v modulu m22_01_L1ABC
############################################################################
# print('===== START načítání modulu', __name__, '=====')


class LA(object):     # Stejný význam má i hlavička: class LA:
    """Třída je bezprostředním potomkem třídy object."""
    cX = '1A_csp'
    cA = 'LA_cls'
    def __init__(self, id):
        self.ID = id        # Identifikátor dané instance
        self.iX = 'LA_isp'
        self.iA = 'LA_ins'
    def __repr__(self):
        return f"{self.__class__.__name__}_{self.ID}"
    def mtdA(self): return f"LA_inst({self})"
    def mtdv(self): return f"LA_virt({self})"

class LB(LA):
    """Třída je dcerou třídy LA => vnučkou třídy object."""
    cX= '1B_csp'
    cB = 'LB_cls'
    def __init__(self, id):
        super().__init__(id)
        self.iX = 'LB_isp'      # Atribut zděděný od rodiče
        self.iB = 'LB_ins'
    def mtdB(self): return f"LB_inst({self})"
    def mtdv(self): return f"LB_virt({self})"

class LC(LB):
    """Třída je dcerou třídy LB => vnučkou třídy LA
       => pravnučkou třídy object."""
    cX = 'LC_csp'
    cC = 'LC_cls'
    def __init__(self, id):
        super().__init__(id)
        self.iX = 'LC_isp'      # Atribut zděděný od rodiče
        self.iC = 'LC_ins'
    def mtdC(self): return f"LC_inst({self})"
    def mtdv(self): return f"LC_virt({self})"


# print('===== KONEC načítání modulu', __name__, '=====')
