#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m25_01_Traced.py
"""
Modul definuje demonstrační jednoduchý dekorátor pro výklad dekorátorů.
"""

# print('===== START načítání modulu', __name__, '=====')



#Výpis 25.3: Definice dekorátoru – třídy traced v modulu m25_01_Traced
############################################################################
class traced:
    """Dekorátor zaznamenávající volání dekorované funkce."""

    level = 0           # Hloubka trasovaných vnoření volání
    indent = "   "      # Odsazovací řetězec

    def __init__(self, fce):
        """Konstruktor - pamatuje si dekorovanou funkci."""
        while type(fce) == traced: print(f"{fce=}"); fce = fce.fce
        self.fce = fce

    def __call__(self, *args, **kwargs):
        """Volání obálky s dekorovanou funkcí.
           Oznámí volání a ukončení dekorované funkce
           s naznačením hladiny vnoření."""
        print(f"{traced.level*traced.indent}>> {self.fce.__name__}("
              f"{args   if len(args)  >0 else ''}"
              f"{kwargs if len(kwargs)>0 else ''})")
        traced.level += 1
        result = self.fce(*args, **kwargs)
        traced.level -= 1
        print(f"{traced.level*traced.indent}<< {self.fce.__name__}="
              f"{result}")
        return result



# print('===== KONEC načítání modulu', __name__, '=====')
