# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m28_02_MetaFce.py
"""
Definice metatřídy MetaFce definované jako funkce.
"""

# print('===== START načítání modulu', __name__, '=====')



#Výpis 28.5: Definice metatřídy MetaFce definované jako funkce
############################################################################
def MetaFce(classname, supers, classdict):
    CLASS = type(classname, supers, classdict)
    print('MetaFce:', f"{classname=}", f"{supers=}",
          f"{list(classdict.keys())}",
          f"Vytvořena a inicializována třída {CLASS}", sep='\n...')
    return CLASS

def __prepare__(classname, supers):
    DICT = {'da': 'MF',  'fa': lambda self: f"{self}"}
    print('MetaFce. __prepare__:', f"{classname=}", f"{supers=}",
          f"Vracím slovník {DICT=}", sep='\n...')
    return DICT
MetaFce.__prepare__ = __prepare__



############################################################################
# Následuje test funkce metatřídy MetaFce

class Matka28Fce:
    pass

print('===== Vytvářím třídu =====')
class Dcera28Fce(Matka28Fce, metaclass=MetaFce):
    """Použitá metatřída MetaFce je definována jako funkce."""
    print('Tělo definované třídy Dcera28Fce spuštěno:')
    data = 'Fce'
    def mtd(self, arg):
        return f"{self.data}({arg})"
    print('Tělo definované třídy Dcera28Fce ukončeno')

print('===== Vytvářím instanci =====')
df = Dcera28Fce()
print(f"{df.data=}, {df.mtd(1)=}, {df.da=}\n{df.fa()=}"
      f"\n{type(Dcera28Fce)=}")



# print('===== KONEC načítání modulu', __name__, '=====')
